--- PKGBUILD.orig	2011-09-09 21:30:01.890724000 +0200
+++ PKGBUILD	2011-09-09 21:32:53.227083000 +0200
@@ -12,6 +12,8 @@
 provides=('zfs')
 options=(!libtool)
 
+source=(zfs.hook zfs.install)
+
 _modules=('spl' 'zfs')
 _gitroot="https://github.com/behlendorf"
 _gitname=stub
@@ -54,6 +56,7 @@
             --prefix=/usr \
             --sysconfdir=/etc \
             --libexecdir=/usr/lib \
+            --with-udevdir=/lib/udev \
             $_conf_opt
         make
         )
@@ -69,4 +72,9 @@
         make DESTDIR="$pkgdir/" install
         )
     done
+
+    install -D "$srcdir"/zfs.hook ${pkgdir}/lib/initcpio/hooks/zfs
+    install -D "$srcdir"/zfs.install ${pkgdir}/lib/initcpio/install/zfs
 } 
+md5sums=('c00cebfa10f93fa8ec7c8fc8a46ed37d'
+         'ecf51b6dd3494ba1eaf516bf8c15b39a')
--- /dev/null	2011-09-09 21:23:36.252360983 +0200
+++ zfs.hook	2011-09-09 21:32:48.558339000 +0200
@@ -0,0 +1,19 @@
+# vim: set ft=sh:
+run_hook ()
+{
+    msg -n ":: zpool import -a..."
+    touch /etc/mtab
+    zpool import -a
+    msg "done."
+    if [ "${rootfstype}" = "zfs" ]; then
+      mount_handler=zfs_mount_handler
+    fi
+}
+zfs_mount_handler() {
+	msn -n ":: Trying to mount zfs root ${root} at $1"
+	if mount -t zfs ${root} $1; then
+          msg "done."
+        else
+          msg "fail."
+	fi
+}
--- /dev/null	2011-09-09 21:23:36.252360983 +0200
+++ zfs.install	2011-09-09 21:32:48.559323000 +0200
@@ -0,0 +1,18 @@
+# vim:set ft=sh:
+
+build()
+{
+    MODULES="spl zavl znvpair zunicode zcommon zfs zpios"
+    BINARIES="/usr/bin/hostid /usr/sbin/zfs /lib/udev/zpool_id /usr/bin/zpool_layout /lib/udev/zvol_id /lib/udev/sas_switch_id /sbin/mount.zfs /usr/sbin/spl /usr/sbin/zfs /usr/sbin/zpool /usr/sbin/zpios /usr/sbin/zinject /bin/bash"
+    FILES="/etc/udev/udev.conf /lib/udev/rules.d/60-zpool.rules /lib/udev/rules.d/60-zvol.rules /etc/zfs/zdev.conf /etc/zfs/zpool.cache"
+    SCRIPT="zfs"
+}
+
+help ()
+{
+cat <<HELPEOF
+    This hook installs the ZFS modules in the initrd. It
+    allows you to boot of ZFS root partitions by setting
+    rootfstype=zfs and rootfs=zrootpool/zfsroot
+HELPEOF
+}
